<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <title>Lucky Dice Casino</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .backgroundimage {
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>

    <script>
        $(document).ready(function(){
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
        const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
        const gEND_OF_ROW_COL = -1;
        const gCOL_LUOT = 0;
        const gCOL_DICE = 1;
        
        $("#btn-nem-dice").click(function(){
            onNemClick()
        })
        $("#btn-dice-history").click(function(){
            onBtnClickDiceHistoryClick();
        })
        
        function onNemClick() {
            var vUser = {
                username: "",
                firstname: "",
                lastname: ""
            }
            //B1 
            getInfo(vUser);
            //B2
            if (validateCheck(vUser)) {
                var vXmlHttpDice = new XMLHttpRequest();
                //B3
                callApi(vXmlHttpDice, vUser);
                //B4
                showApi(vXmlHttpDice, vUser);

            }

        }

        function onBtnClickDiceHistoryClick() {
            var vUser = {
                username: "",
                firstname: "",
                lastname: ""
            }
            //B1 
            console.log("Nút Dice History được ấn");
            getInfo(vUser);
            //B2
            if (validateCheck(vUser)) {
                var vXmlHttpDice = new XMLHttpRequest();
                //B3

                callApiHistoryDice(vXmlHttpDice, vUser);
                console.log(vXmlHttpDice.responseText);
                //B4
                showApiHistoryDice(vXmlHttpDice, vUser);
            }
        }




        function getInfo(paramUser) {
            var vUserName = $("#inp-user-name");
            var vFirstName = $("#inp-first-name");
            var vLastName = $("#inp-last-name");

            paramUser.username = vUserName.val().trim();
            paramUser.firstname = vFirstName.val().trim();
            paramUser.lastname = vLastName.val().trim();
        }

        function validateCheck(paramUser) {
            if (paramUser.username == "") {
                alert("Cần nhập Username !!!");
                return false;
            }
            else if (paramUser.firstname == "") {
                alert("Cần nhập Firstname !!!");
                return false;
            }
            else if (paramUser.lastname == "") {
                alert("Cần nhập Lastname !!!");
                return false;
            }
            return true;
        }

        //Call Api ném mới
        function callApi(paramXmlHttp, paramUser) {
            paramXmlHttp.open("POST", gBASE_URL + "/dice", true);
            paramXmlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
            paramXmlHttp.send(JSON.stringify(paramUser));  //chuyển Json object sang string
        }
        //Xử lí hiện thị cho ném mới
        function showApi(paramXmlHttp, paramUser) {
            var vImgDice = $("#img-nem-dice");
            var vThongBao = $("#p-thong-bao");
            var vVoucher = $("#p-voucher-id");
            var vPhanTramGiam = $("#p-voucher-percent");
            var vGift = $("#img-present");


            paramXmlHttp.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    //hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
                    console.log(paramXmlHttp.responseText);
                    // parsing to object
                    vResponse = JSON.parse(paramXmlHttp.responseText);
                    console.log(vResponse);
                    //Hiển thị dice mới và thông báo
                    switch (vResponse.dice) {
                        case 1: {
                            vImgDice.prop("src", "LuckyDiceImages/1.png");
                            vThongBao.html("Chúc bạn may mắn lần sau !!!");
                            break;
                        }
                        case 2: {
                            vImgDice.prop("src", "LuckyDiceImages/2.png");
                            vThongBao.html("Chúc bạn may mắn lần sau !!!");
                            break;
                        }
                        case 3: {
                            vImgDice.prop("src", "LuckyDiceImages/3.png");
                            vThongBao.html("Chúc bạn may mắn lần sau !!!");
                            break;
                        }
                        case 4: {
                            vImgDice.prop("src", "LuckyDiceImages/4.png");
                            vThongBao.html("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
                            break;
                        }
                        case 5: {
                            vImgDice.prop("src", "LuckyDiceImages/5.png");
                            vThongBao.html("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
                            break;
                        }
                        case 6: {
                            vImgDice.prop("src", "LuckyDiceImages/6.png");
                            vThongBao.html("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
                            break;
                        }
                        default: break;
                    }

                    //Hiển thị voucher và % giảm, nếu ko có hiện No ID và 0 giảm
                    if (vResponse.voucher != null) {
                        vVoucher.html(vResponse.voucher.maVoucher);
                        vPhanTramGiam.html(vResponse.voucher.phanTramGiamGia + "%");
                    }
                    else {
                        vVoucher.html("No ID");
                        vPhanTramGiam.html("0%");
                    }

                    //Hiển thị prize
                    var vMu = "Mũ";
                    var vAo = "Áo";
                    var vXemay = "Xe máy";
                    var vOto = "Ô tô";
                    if (vResponse.prize != null) {
                        if (vResponse.prize.normalize('NFC') == vMu.normalize('NFC')) {
                            vGift.prop("src", "LuckyDiceImages/hat.jpg");
                        }
                        else if (vResponse.prize.normalize('NFC') == vAo.normalize('NFC')) {
                            vGift.prop("src", "LuckyDiceImages/t-shirt.jpg");
                        }
                        else if (vResponse.prize.normalize('NFC') == vXemay.normalize('NFC')) {
                            vGift.prop("src", "LuckyDiceImages/xe-may.jpg");
                        }
                        else if (vResponse.prize.normalize('NFC') == vOto.normalize('NFC')) {
                            vGift.prop("src", "LuckyDiceImages/car.jpg");
                        }
                    }
                    else {
                        vGift.prop("src", "LuckyDiceImages/nogift.png");
                    }
                }
            }
        }

        //Call Api hiển thị lịch sử ném
        function callApiHistoryDice(paramXmlHttp, paramUser) {
            paramXmlHttp.open("GET", gBASE_URL + "/dice-history?username=" + paramUser.username, true);
            paramXmlHttp.send();
        }
        //Xử lý hiển thị lịch sử ném
        function showApiHistoryDice(paramXmlHttp, paramUser) {
            paramXmlHttp.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        console.log(paramXmlHttp.responseText);
                        var vResponse = JSON.parse(paramXmlHttp.responseText);
                        console.log(vResponse);

                        var vDiceHistoryTable = document.getElementById("history-placeholder-table");
                        var vTableBody = vDiceHistoryTable.getElementsByTagName("tbody")[0];

                        while (vDiceHistoryTable.rows.length > 1) {
                            vDiceHistoryTable.deleteRow(1);
                        }

                        // -- thêm các dòng vào bảng 
                        for (var bIndex = 0; bIndex < vResponse.dices.length; bIndex++) {
                            // insert to the end of table, thêm row mới vào bảng( <tr> </tr>)
                            var vNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
                            // them moi 02 cell (03 ô) (<td> </td> 
                            var vGame = vNewRow.insertCell(gCOL_LUOT);
                            var vDice = vNewRow.insertCell(gCOL_DICE);
                            //gán giá trị cho các ô
                            vGame.innerHTML = bIndex + 1;
                            vDice.innerHTML = vResponse.dices[bIndex];
                        }
                    }
                }
        }

    })
    </script>

<body>
    <div class="container-fluid">
        <div class="backgroundimage"></div>
    </div>
    <div class="container">
        <div class="row ">
            <div class="col-sm-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label>Username</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4 ">
                        <label>Firstname</label>
                    </div>
                    <div class="col-8 ">
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label>Lastname</label>
                    </div>
                    <div class="col-8 ">
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-sm-4 text-center ">
                <div class="row form-group">
                    <div class="col-12">
                        <input id="btn-nem-dice" class="btn btn-success button-width w-75"
                            value="Ném" type="button">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-12 ">
                        <img id="img-nem-dice" class="img-thumbnail"
                            src="https://dictionary.cambridge.org/vi/images/thumb/dice_noun_002_10624.jpg?version=5.0.158">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <p id="p-thong-bao">Chúc mừng</p>
                    </div>
                </div>

            </div>
            <div class="col-sm-3 text-center">
                <div class="row form-group">
                    <div class="col-12 ">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/nogift.png">
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group">
            <div class="row text-center">
                <div class="col-12 ">
                    <button id="btn-dice-history"
                        class="btn btn-primary button-width w-25">Dice History</button>
                    <input id="btn-voucher-history" class="btn btn-primary button-width w-25" value="Voucher History"
                        type="button">
                    <input id="btn-present-history" class="btn btn-primary button-width w-25" value="Present History"
                        type="button">
                </div>
            </div>
        </div>

        <div class="row ">
            <div class="col-12 ">
                <table id="history-placeholder-table" class="table table-striped table-hover border">
                    <tbody>
                        <tr>
                            <th>Lượt</th>
                            <th>Dice</th>
                        </tr>
                        <tr>
                            <td>1</td>
                            <td>2</td>
                        </tr>
                        <tr>
                            <td>2</td>
                            <td>6</td>
                        </tr>
                        <tr>
                            <td>3</td>
                            <td>4</td>
                        </tr>
                        <tr>
                            <td>4</td>
                            <td>5</td>
                        </tr>
                        <tr>
                            <td>5</td>
                            <td>4</td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>

</html>